math2d = require "math2d"
function get_area(pos, size) -- cannot use math2d.bounding_box.create_from_centre because of floor and ceil
	pos = math2d.position.ensure_xy(pos)
	return {left_top={x=math.floor(pos.x - size), y=math.floor(pos.y - size)}, right_bottom={x=math.ceil(pos.x + size), y=math.ceil(pos.y + size)}}
end

function get_area_positions(area)
	local arr = {}
	for x=area.left_top.x,area.right_bottom.x,1 do
		for y=area.left_top.y,area.right_bottom.y,1 do
			table.insert(arr, {x, y})
		end
	end
	return arr
end

function place_resources(surface, pos_arr)
	local calcresult = surface.calculate_tile_properties({"entity:crude-oil:probability", "entity:crude-oil:richness"}, pos_arr)
	for i,v in ipairs(calcresult["entity:crude-oil:probability"]) do
		if calcresult["entity:crude-oil:richness"][i] > 0 then
			rendering.draw_text{text=string.format("%.2f", v), surface=surface, target={pos_arr[i][1], pos_arr[i][2]}, color={1, 1, 1}, scale=0.5}
			rendering.draw_text{text=string.format("%.2f", calcresult["entity:crude-oil:richness"][i]), surface=surface, target={pos_arr[i][1], pos_arr[i][2]+0.2}, color={1, 1, 0}, scale=0.3}
			if v > 0 then rendering.draw_circle{color={0, 0, 1}, radius=0.2, surface=surface, target={pos_arr[i][1]+0.5, pos_arr[i][2]+0.5}, filled=true} end
		end
	end
end

commands.add_command("test", nil, function(cmd)
	local params = {}
	for i in string.gmatch(cmd.parameter or "", "%S+") do
		table.insert(params, i)
	end
	
	if params[1] == "gen" and cmd.player_index then -- chart chunks
		local player = game.get_player(cmd.player_index)
		local radius = tonumber(params[2]) or 5
		player.surface.request_to_generate_chunks(player.position, radius)
		player.surface.force_generate_chunk_requests()
		player.force.chart_all()
		place_resources(player.surface, get_area_positions(get_area(player.position, radius*32)))
	end
end)